/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.c
* Author             : kingsley@wch
* Version            : V1.0
* Date               : 2021/5/31
* Description 		 : boot and interrupt remap
*******************************************************************************/

#include "CH57x_common.h"

__align(4) UINT32 CapBuf[100];
volatile UINT8 capFlag = 0;

void DebugInit(void)		
{
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
}


typedef  void (*app_t)(void);

void iap_load_app(uint32_t appxaddr) {
    app_t jump2app;
   
    //disable all interrupt
    NVIC->ICER[0] = 0xffffffff;
    
    //for ch579 interrupt vector remap flag
    R8_GLOB_RESET_KEEP &= ~0x80;
    
    jump2app=(app_t)*(__IO uint32_t*)(appxaddr+4);//ûڶΪʼַ(λַ)
    __set_MSP(*(__IO uint32_t*)appxaddr);//ʼAPPջָ(ûĵһڴջַ)
    jump2app();//תAPP.

}


int main()
{     
    
    // bit7 = 1 of R8_GLOB_RESET_KEEP at this boot
    // bit7 = 0 of R8_GLOB_RESET_KEEP at this boot
    // at boot
    R8_GLOB_RESET_KEEP |= 0x80;
    
    
    
    UINT8  i;
    UINT32 x = 0;
  
 
    DebugInit();
    PRINT( "Start @ChipID=%02X\n", R8_CHIP_ID );
    PRINT("WE ARE AT boot\r\n");
#if 1     
    
    GPIOB_SetBits( GPIO_Pin_3 );
    GPIOB_ModeCfg( GPIO_Pin_3, GPIO_ModeOut_PP_5mA );
    
    TMR0_TimerInit( FREQ_SYS/10 );          
    TMR0_ITCfg(ENABLE, TMR0_3_IT_CYC_END);         
    NVIC_EnableIRQ( TMR0_IRQn );
    
#endif 




    DelayMs(1000);
    PRINT("start jump to app\r\n");
    DelayMs(5); //waiting print
    iap_load_app(0x2000);
    while(1);    
}



void TMR0_IRQHandler( void )        // TMR0 ʱж
{
    if( TMR0_GetITFlag( TMR0_3_IT_CYC_END ) )
    {
        TMR0_ClearITFlag( TMR0_3_IT_CYC_END );      // жϱ־
        GPIOB_InverseBits( GPIO_Pin_3 );      
        PRINT("WE ARE AT boot interrupt \r\n");        
    }
}






